tpmtoken_protect_tests.sh 3.6 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153
  1. #! /bin/sh
  2. #
  3. # Copyright (c) International Business Machines Corp., 2005
  4. #
  5. # This program is free software; you can redistribute it and#or modify
  6. # it under the terms of the GNU General Public License as published by
  7. # the Free Software Foundation; either version 2 of the License, or
  8. # (at your option) any later version.
  9. #
  10. # This program is distributed in the hope that it will be useful, but
  11. # WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  12. # or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
  13. # for more details.
  14. #
  15. # You should have received a copy of the GNU General Public License
  16. # along with this program; if not, write to the Free Software
  17. # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
  18. #
  19. setup()
  20. {
  21. RC=0 # Return code from commands.
  22. if [ -z "$LTPTMP" ] && [ -z "$TMPBASE" ]
  23. then
  24. LTPTMP="/tmp"
  25. else
  26. LTPTMP="$TMPBASE"
  27. fi
  28. export TPM_TMPFILE="$LTPTMP/tst_tpm.err"
  29. rm -f $TPM_TMPFILE 2>&1
  30. # Set the file to be protected and the related output files
  31. export TPM_DATAFILE="$LTPBIN/tpmtoken_protect_data.txt"
  32. export TPM_ENCDATA="$LTPTMP/tst_tpm_data.enc"
  33. rm -f $TPM_ENCDATA 2>&1
  34. export TPM_DECDATA="$LTPTMP/tst_tpm_data.dec"
  35. rm -f $TPM_DECDATA 2>&1
  36. # Set known password values
  37. if [ -z "$P11_SO_PWD" ]
  38. then
  39. export P11_SO_PWD="P11 SO PWD"
  40. fi
  41. if [ -z "$P11_USER_PWD" ]
  42. then
  43. export P11_USER_PWD="P11 USER PWD"
  44. fi
  45. tst_resm TINFO "INIT: Inititalizing tests."
  46. which tpmtoken_protect 1>$TPM_TMPFILE 2>&1 || RC=$?
  47. if [ $RC -ne 0 ]
  48. then
  49. tst_brk TBROK $TPM_TMPFILE NULL \
  50. "Setup: tpmtoken_protect command does not exist. Reason:"
  51. return $RC
  52. fi
  53. return $RC
  54. }
  55. test01()
  56. {
  57. RC=0 # Return value from commands
  58. export TCID=tpmtoken_protect01 # Test ID
  59. export TST_COUNT=1 # Test number
  60. tpmtoken_protect_tests_exp01.sh 1>$TPM_TMPFILE 2>&1 || RC=$?
  61. if [ $RC -eq 0 ]
  62. then
  63. tst_resm TPASS "'tpmtoken_protect -e -i $TPM_DATAFILE -o $TPM_ENCDATA' passed."
  64. RC=0
  65. else
  66. tst_res TFAIL $TPM_TMPFILE "'tpmtoken_protect -e -i $TPM_DATAFILE -o $TPM_ENCDATA' failed."
  67. RC=1
  68. fi
  69. return $RC
  70. }
  71. test02()
  72. {
  73. RC=0 # Return value from commands
  74. export TCID=tpmtoken_protect02 # Test ID
  75. export TST_COUNT=2 # Test number
  76. tpmtoken_protect_tests_exp02.sh 1>$TPM_TMPFILE 2>&1 || RC=$?
  77. if [ $RC -eq 0 ]
  78. then
  79. tst_resm TPASS "'tpmtoken_protect -d -i $TPM_ENCDATA -o $TPM_DECDATA' passed."
  80. RC=0
  81. else
  82. tst_res TFAIL $TPM_TMPFILE "'tpmtoken_protect -d -i $TPM_ENCDATA -o $TPM_DECDATA' failed."
  83. RC=1
  84. fi
  85. return $RC
  86. }
  87. test03()
  88. {
  89. RC=0 # Return value from commands
  90. export TCID=tpmtoken_protect03 # Test ID
  91. export TST_COUNT=3 # Test number
  92. diff $TPM_DATAFILE $TPM_DECDATA 1>$TPM_TMPFILE 2>&1 || RC=$?
  93. if [ $RC -eq 0 ]
  94. then
  95. tst_resm TPASS "'diff $TPM_DATAFILE $TPM_DECDATA' passed."
  96. RC=0
  97. else
  98. tst_res TFAIL $TPM_TMPFILE "'diff $TPM_DATAFILE $TPM_DECDATA' failed."
  99. RC=1
  100. fi
  101. return $RC
  102. }
  103. cleanup()
  104. {
  105. rm -f $TPM_TMPFILE 2>&1
  106. rm -f $TPM_ENCDATA 2>&1
  107. rm -f $TPM_DECDATA 2>&1
  108. }
  109. # Function: main
  110. #
  111. # Description: - Execute all tests, report results.
  112. #
  113. # Exit: - zero on success
  114. # - non-zero on failure.
  115. TFAILCNT=0 # Set TFAILCNT to 0, increment on failure.
  116. RC=0 # Return code from tests.
  117. export TCID=tpmtoken_protect # Test ID
  118. export TST_TOTAL=3 # Total numner of tests in this file.
  119. export TST_COUNT=0 # Initialize identifier
  120. if [ -n "$TPM_NOPKCS11" ]
  121. then
  122. tst_resm TINFO "'tpmtoken_protect' skipped."
  123. exit $TFAILCNT
  124. fi
  125. setup || exit $RC # Exit if initializing testcases fails.
  126. test01 || TFAILCNT=$(($TFAILCNT+1))
  127. test02 || TFAILCNT=$(($TFAILCNT+1))
  128. test03 || TFAILCNT=$(($TFAILCNT+1))
  129. cleanup
  130. exit $TFAILCNT